Loading...
Searching...
No Matches
Exiv2::TimeValue Class Reference

Value for simple ISO 8601 times. More...

`#include <value.hpp>`

Inheritance diagram for Exiv2::TimeValue:
[legend]

## Classes

struct | Time
| Simple Time helper structure. More...

## Public Types

using | UniquePtr = std::unique_ptr< TimeValue >
| Shortcut for a TimeValue auto pointer.
Public Types inherited from Exiv2::Value
using | UniquePtr = std::unique_ptr< Value >
| Shortcut for a Value auto pointer.

## Public Member Functions

Creators
| TimeValue ()
| Default constructor.
| TimeValue (int32_t hour, int32_t minute, int32_t second=0, int32_t tzHour=0, int32_t tzMinute=0)
| Constructor.
Manipulators
int | read (const byte *buf, size_t len, ByteOrder byteOrder=invalidByteOrder) override
int | read (const std::string &buf) override
| Set the value to that of the string buf.
void | setTime (const Time &src)
| Set the time.
Public Member Functions inherited from Exiv2::Value
| Value (TypeId typeId)
| Constructor, taking a type id to initialize the base class with.
virtual | ~Value ()=default
| Virtual destructor.
virtual int | setDataArea (const byte *buf, size_t len)
| Set the data area, if the value has one by copying (cloning) the buffer pointed to by buf.
TypeId | typeId () const
| Return the type identifier (Exif data format type).
UniquePtr | clone () const
| Return an auto-pointer to a copy of itself (deep copy). The caller owns this copy and the auto-pointer ensures that it will be deleted.
std::string | toString () const
| Return the value as a string. Implemented in terms of write(std::ostream& os) const of the concrete class.
virtual std::string | toString (size_t n) const
| Return the n-th component of the value as a string. The default implementation returns toString(). The behaviour of this method may be undefined if there is no n-th component.
virtual size_t | sizeDataArea () const
| Return the size of the data area, 0 if there is none.
virtual DataBuf | dataArea () const
| Return a copy of the data area if the value has one. The caller owns this copy and DataBuf ensures that it will be deleted.
bool | ok () const
| Check the ok status indicator. After a to<Type> conversion, this indicator shows whether the conversion was successful.

## Accessors

UniquePtr | clone () const
size_t | copy (byte *buf, ByteOrder byteOrder=invalidByteOrder) const override
| Write value to a character data buffer.
virtual const Time & | getTime () const
| Return time struct containing time information.
size_t | count () const override
| Return the number of components of the value.
size_t | size () const override
| Return the size of the value in bytes.
std::ostream & | write (std::ostream &os) const override
| Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).
int64_t | toInt64 (size_t n=0) const override
| Returns number of seconds in the day in UTC.
uint32_t | toUint32 (size_t n=0) const override
| Returns number of seconds in the day in UTC.
float | toFloat (size_t n=0) const override
| Returns number of seconds in the day in UTC converted to float.
Rational | toRational (size_t n=0) const override
| Returns number of seconds in the day in UTC converted to Rational.

## Additional Inherited Members

Static Public Member Functions inherited from Exiv2::Value
static UniquePtr | create (TypeId typeId)
| A (simple) factory to create a Value type.
Protected Member Functions inherited from Exiv2::Value
| Value (const Value &)=default
Value & | operator= (const Value &)=default
| Assignment operator. Protected so that it can only be used by subclasses but not directly.
Protected Attributes inherited from Exiv2::Value
bool | ok_ {true}
| Indicates the status of the previous to<Type> conversion.

## Detailed Description

Value for simple ISO 8601 times.

This class is limited to handling simple time strings in the ISO 8601 format HHMMSS±HHMM where HHMMSS refers to local hour, minute and seconds and ±HHMM refers to hours and minutes ahead or behind Universal Coordinated Time.

## Member Function Documentation

## copy()

size_t Exiv2::TimeValue::copy | ( | byte * | buf,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  | const

override virtual

Write value to a character data buffer.

The user must ensure that the buffer has enough memory. Otherwise the call results in undefined behaviour.

Note
  The byte order is required by the interface but not used by this method, so just use the default.

Parameters

  buf | Data buffer to write to.
  byteOrder | Byte order. Not used.

Returns
  Number of characters written.

Implements Exiv2::Value.

References Exiv2::Internal::enforce(), Exiv2::TimeValue::Time::hour, Exiv2::TimeValue::Time::minute, Exiv2::TimeValue::Time::second, Exiv2::TimeValue::Time::tzHour, and Exiv2::TimeValue::Time::tzMinute.

## count()

size_t Exiv2::TimeValue::count | ( |  | ) | const

override virtual

Return the number of components of the value.

Implements Exiv2::Value.

References size().

## read() [1/2]

int Exiv2::TimeValue::read | ( | const byte * | buf,
|  | size_t | len,
|  | ByteOrder | byteOrder = `invalidByteOrder`
| ) |  |

override virtual

Returns
  0 if successful
  1 in case of an unsupported time format

Implements Exiv2::Value.

References read().

Referenced by read().

## read() [2/2]

int Exiv2::TimeValue::read | ( | const std::string & | buf | ) |

override virtual

Set the value to that of the string buf.

Parameters

  buf | String containing the time.

Returns
  0 if successful
  1 in case of an unsupported time format

Implements Exiv2::Value.

References EXV_WARNING, Exiv2::TimeValue::Time::hour, Exiv2::TimeValue::Time::minute, Exiv2::TimeValue::Time::second, Exiv2::TimeValue::Time::tzHour, and Exiv2::TimeValue::Time::tzMinute.

## setTime()

void Exiv2::TimeValue::setTime | ( | const Time & | src | ) |

Set the time.

## size()

size_t Exiv2::TimeValue::size | ( |  | ) | const

override virtual

Return the size of the value in bytes.

Implements Exiv2::Value.

Referenced by count().

## toFloat()

float Exiv2::TimeValue::toFloat | ( | size_t | n = `0` | ) | const

override virtual

Returns number of seconds in the day in UTC converted to float.

Implements Exiv2::Value.

References toInt64().

## toInt64()

int64_t Exiv2::TimeValue::toInt64 | ( | size_t | n = `0` | ) | const

override virtual

Returns number of seconds in the day in UTC.

Implements Exiv2::Value.

References Exiv2::TimeValue::Time::hour, Exiv2::TimeValue::Time::minute, Exiv2::Value::ok_, Exiv2::TimeValue::Time::second, Exiv2::TimeValue::Time::tzHour, and Exiv2::TimeValue::Time::tzMinute.

Referenced by toFloat(), toRational(), and toUint32().

## toRational()

Rational Exiv2::TimeValue::toRational | ( | size_t | n = `0` | ) | const

override virtual

Returns number of seconds in the day in UTC converted to Rational.

Implements Exiv2::Value.

References toInt64().

## toUint32()

uint32_t Exiv2::TimeValue::toUint32 | ( | size_t | n = `0` | ) | const

override virtual

Returns number of seconds in the day in UTC.

Implements Exiv2::Value.

References toInt64().

## write()

std::ostream & Exiv2::TimeValue::write | ( | std::ostream & | os | ) | const

override virtual

Write the value to an output stream. You do not usually have to use this function; it is used for the implementation of the output operator for Value, operator<<(std::ostream &os, const Value &value).

Implements Exiv2::Value.

References Exiv2::TimeValue::Time::hour, Exiv2::TimeValue::Time::minute, Exiv2::TimeValue::Time::second, Exiv2::TimeValue::Time::tzHour, and Exiv2::TimeValue::Time::tzMinute.

The documentation for this class was generated from the following files:

- value.hpp
- value.cpp